<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/Parts/Inheritance.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/Parts/Inheritance.py</title>
<link href="../../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/Parts/Inheritance.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> Parameter</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Part <span class="py-keyword">import</span> Part</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Fragments <span class="py-keyword">import</span> *</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Tags <span class="py-keyword">import</span> *</span>
<a id="line14"></a><span class="lineno"> 14</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Parts/Inheritance.html#short_name">short_name</a>(decl):</span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line">   <span class="py-keyword">return</span> isinstance(decl, ASG.Function) <span class="py-keyword">and</span> decl.real_name[-1] <span class="py-keyword">or</span> decl.name[-1]</span>
<a id="line17"></a><span class="lineno"> 17</span>
<a id="line18"></a><span class="lineno"> 18</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Parts/Inheritance/Inheritance.html">Inheritance</a>(Part):</span>
<a id="line20"></a><span class="lineno"> 20</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line">   fragments = Parameter([InheritanceFormatter()],</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">                         <span class="py-string">''</span>)</span>
<a id="line23"></a><span class="lineno"> 23</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Parts/Inheritance/Inheritance.html#register">register</a>(self, view):</span>
<a id="line25"></a><span class="lineno"> 25</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">      Part.register(self, view)</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">      self.__start_list = 0</span>
<a id="line28"></a><span class="lineno"> 28</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Parts/Inheritance/Inheritance.html#process">process</a>(self, decl):</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">      <span class="py-string">&quot;Walk the hierarchy to find inherited members to print.&quot;</span></span>
<a id="line31"></a><span class="lineno"> 31</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">      <span class="py-keyword">if</span> <span class="py-keyword">not</span> isinstance(decl, (ASG.Class, ASG.ClassTemplate)): <span class="py-keyword">return</span></span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">      self.write_start()</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">      names = [short_name(d) <span class="py-keyword">for</span> d <span class="py-keyword">in</span> decl.declarations]</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">      self._process_superclasses(decl, names)</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">      self.write_end()</span>
<a id="line37"></a><span class="lineno"> 37</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Parts/Inheritance/Inheritance.html#_process_class">_process_class</a>(self, class_, names):</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">      <span class="py-string">&quot;Prints info for the given class, and calls _process_superclasses after&quot;</span></span>
<a id="line40"></a><span class="lineno"> 40</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">      sorter = self.processor.sorter.clone(class_.declarations)</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">      child_names = []</span>
<a id="line43"></a><span class="lineno"> 43</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">      <span class="py-comment"># Iterate through the sections</span></span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">      <span class="py-keyword">for</span> section <span class="py-keyword">in</span> sorter:</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">         <span class="py-comment"># Write a heading</span></span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">         heading = section+<span class="py-string">' Inherited from '</span>+ str(self.scope().prune(class_.name))</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">         started = 0 <span class="py-comment"># Lazy section start incase no details for this section</span></span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">         <span class="py-comment"># Iterate through the children in this section</span></span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">         <span class="py-keyword">for</span> child <span class="py-keyword">in</span> sorter[section]:</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">            child_name = short_name(child)</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">            <span class="py-keyword">if</span> child_name <span class="py-keyword">in</span> names:</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">               <span class="py-keyword">continue</span></span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">            <span class="py-comment"># FIXME: This doesn't account for the inheritance type</span></span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">            <span class="py-comment"># (private etc)</span></span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">            <span class="py-keyword">if</span> child.accessibility == ASG.PRIVATE:</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">               <span class="py-keyword">continue</span></span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">            <span class="py-comment"># Don't include constructors and destructors!</span></span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">            <span class="py-keyword">if</span> (isinstance(child, ASG.Function) <span class="py-keyword">and</span></span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">                child.file.annotations[<span class="py-string">'language'</span>] == <span class="py-string">'C++'</span> <span class="py-keyword">and</span></span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">                len(child.real_name) &gt; 1):</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">               <span class="py-keyword">if</span> child.real_name[-1] == child.real_name[-2]: <span class="py-keyword">continue</span></span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">               <span class="py-keyword">elif</span> child.real_name[-1] == <span class="py-string">&quot;~&quot;</span>+child.real_name[-2]: <span class="py-keyword">continue</span></span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">            <span class="py-comment"># FIXME: skip overriden declarations</span></span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">            child_names.append(child_name)</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">            <span class="py-comment"># Check section heading</span></span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">            <span class="py-keyword">if</span> <span class="py-keyword">not</span> started:</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">               started = 1</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">               self.write_section_start(heading)</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">            child.accept(self)</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">         <span class="py-comment"># Finish the section</span></span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">         <span class="py-keyword">if</span> started: self.write_section_end(heading)</span>
<a id="line73"></a><span class="lineno"> 73</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">      self._process_superclasses(class_, names + child_names)</span>
<a id="line75"></a><span class="lineno"> 75</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Parts/Inheritance/Inheritance.html#_process_superclasses">_process_superclasses</a>(self, class_, names):</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Iterates through the superclasses of clas and calls _process_clas for</span></span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line"><span class="py-string">      each&quot;&quot;&quot;</span></span>
<a id="line79"></a><span class="lineno"> 79</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">      <span class="py-keyword">for</span> inheritance <span class="py-keyword">in</span> class_.parents:</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">         parent = inheritance.parent</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">         <span class="py-keyword">if</span> isinstance(parent, ASG.DeclaredTypeId):</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">            parent = parent.declaration</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">            <span class="py-keyword">if</span> isinstance(parent, ASG.Class):</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">               self._process_class(parent, names)</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">               <span class="py-keyword">continue</span></span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">         <span class="py-comment">#print &quot;Ignoring&quot;, parent.__class__.__name__, &quot;parent of&quot;, clas.name</span></span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">         <span class="py-keyword">pass</span> <span class="py-comment">#ignore</span></span>
<a id="line89"></a><span class="lineno"> 89</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Parts/Inheritance/Inheritance.html#write_section_start">write_section_start</a>(self, heading):</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Creates a table with one row. The row has a td of class 'heading'</span></span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line"><span class="py-string">      containing the heading string&quot;&quot;&quot;</span></span>
<a id="line93"></a><span class="lineno"> 93</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">      self.write(<span class="py-string">'&lt;table width=&quot;100%%&quot; summary=&quot;%s&quot;&gt;\n'</span>%heading)</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">      self.write(<span class="py-string">'&lt;tr&gt;&lt;td colspan=&quot;2&quot; class=&quot;heading&quot;&gt;'</span> + heading + <span class="py-string">'&lt;/td&gt;&lt;/tr&gt;\n'</span>)</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">      self.write(<span class="py-string">'&lt;tr&gt;&lt;td class=&quot;inherited&quot;&gt;'</span>)</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">      self.__start_list = 1</span>
<a id="line98"></a><span class="lineno"> 98</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Parts/Inheritance/Inheritance.html#write_section_item">write_section_item</a>(self, text):</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Adds a table row&quot;&quot;&quot;</span></span>
<a id="line101"></a><span class="lineno">101</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">      <span class="py-keyword">if</span> self.__start_list:</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">         self.write(text)</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">         self.__start_list = 0</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">      <span class="py-keyword">else</span>:</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">         self.write(<span class="py-string">',\n'</span>+text)</span>
<a id="line107"></a><span class="lineno">107</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Parts/Inheritance/Inheritance.html#write_section_end">write_section_end</a>(self, heading):</span>
<a id="line109"></a><span class="lineno">109</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">      self.write(<span class="py-string">'&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n'</span>)</span>
<a id="line111"></a><span class="lineno">111</span>
<a id="line112"></a><span class="lineno">112</span>
<a id="line113"></a><span class="lineno">113</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:13 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
